_global.FTreeDataProviderClass = function()
{
};
FTreeDataProviderClass.prototype = new _global.DataProviderClass();
FTreeDataProviderClass.prototype.setRootNode = function(root)
{
   this.root = root;
   this.removeAll();
   if(this.root != null)
   {
      this.addNodeAt(0,0,this.root);
   }
   this.updateViews({event:"newRoot"});
};
FTreeDataProviderClass.prototype.addNodeAt = function(n, level, node)
{
   node.level = level++;
   node.uiIndex = n;
   this.addItemAt(n++,node);
   if(node.isBranch() && node.isOpen())
   {
      var i = 0;
      while(i < node.length)
      {
         n = this.addNodeAt(n,level,node[i]);
         i++;
      }
   }
   return n;
};
FTreeDataProviderClass.prototype.updateBranch = function(index)
{
   var item = this.getItemAt(index);
   if(!item.isBranch())
   {
      return undefined;
   }
   var n = index + 1;
   var level = item.level + 1;
   var i = n;
   while(i < this.items.length && this.items[i].level >= level)
   {
      i++;
   }
   this.removeItemsAt(n,i - n);
   if(item.isOpen())
   {
      var i = 0;
      while(i < item.length)
      {
         n = this.addNodeAt(n,level,item[i]);
         i++;
      }
   }
   while(n < this.items.length)
   {
      this.items[n].uiIndex = n;
      n++;
   }
};
FTreeDataProviderClass.prototype.removeItemsAt = function(index, count)
{
   var rtn = null;
   if(count > 0)
   {
      rtn = this.items[index];
      this.items.splice(index,count);
   }
   var eventObj = {event:"nodeExpansion",row:index};
   this.updateViews(eventObj);
   return rtn;
};
FTreeDataProviderClass.prototype.sortItemsBy = function(fieldName, order)
{
};
