_global.FTreeNode = function(label, data, iconSymbolName)
{
   this.label = label;
   this.data = data;
   if(iconSymbolName != undefined && iconSymbolName != "")
   {
      this.iconSymbolName = iconSymbolName;
   }
   this.open = false;
   this.branch = false;
   this.index = 0;
   this.level = 0;
   this.numchildren = 0;
   this.__ID__ = FTreeNode.prototype.__GID__++;
};
FTreeNode.prototype = new Array();
FTreeNode.prototype.__GID__ = 0;
FTreeNode.prototype.addNode = function(kid)
{
   this.addNodeAt(this.length,kid);
   return this;
};
FTreeNode.prototype.addNodeAt = function(index, kid)
{
   this.branch = true;
   this.splice(index,0,kid);
   kid.index = index;
   kid.parent = this;
   kid.level = this.level + 1;
   var numkids = kid.countChildren(0);
   kid.numchildren = numkids;
   var cp = this;
   while(cp != null)
   {
      cp.numchildren += 1 + numkids;
      cp = cp.parent;
   }
   var i;
   i = index + 1;
   while(i < this.length)
   {
      this[i].index = i;
      i++;
   }
   return this;
};
FTreeNode.prototype.getChildNodes = function()
{
   return this;
};
FTreeNode.prototype.getData = function()
{
   return this.data;
};
FTreeNode.prototype.getLabel = function()
{
   return this.label;
};
FTreeNode.prototype.getNodeAt = function(index)
{
   return this[index];
};
FTreeNode.prototype.getNumChildren = function()
{
   return this.numchildren;
};
FTreeNode.prototype.getIconSymbolName = function()
{
   return this.iconSymbolName;
};
FTreeNode.prototype.getParentNode = function()
{
   return this.parent;
};
FTreeNode.prototype.isBranch = function()
{
   return this.branch;
};
FTreeNode.prototype.isOpen = function()
{
   return this.open;
};
FTreeNode.prototype.removeNode = function(node)
{
   this.removeNodesAt(node.index,1);
   return this;
};
FTreeNode.prototype.removeNodeAt = function(index)
{
   this.removeNodesAt(index,1);
   return this;
};
FTreeNode.prototype.removeNodesAt = function(index, numNodes)
{
   if(index < this.length)
   {
      var i = numNodes;
      var nukedKids = 0;
      while(i > 0)
      {
         nukedKids += 1 + this[index].numchildren;
         this.splice(index,1);
         i--;
      }
      var cp = this;
      while(cp != null)
      {
         cp.numchildren -= nukedKids;
         cp = cp.parent;
      }
      i = index;
      while(i < this.length)
      {
         this[i].index = i;
         i++;
      }
   }
   return this;
};
FTreeNode.prototype.setChildNodes = function(kids)
{
   this.splice(0,this.length);
   if(!(kids instanceof FTreeNode) && kids instanceof Array)
   {
      var i = 0;
      i = 0;
      while(i < kids.length)
      {
         this.addNodeAt(i,kids[i]);
         i++;
      }
   }
   return this;
};
FTreeNode.prototype.setData = function(data)
{
   this.data = data;
   return this;
};
FTreeNode.prototype.setDataProvider = function(dataProvider, labelField, dataField)
{
   if(labelField == undefined)
   {
      labelField = "label";
   }
   if(dataField == undefined)
   {
      dataField = "data";
   }
   var isArray = dataProvider instanceof Array;
   var len = !isArray ? dataProvider.getLength() : dataProvider.length;
   var i = 0;
   while(i < len)
   {
      var itm = !isArray ? dataProvider.getItemAt(i) : dataProvider[i];
      if(typeof itm == "string")
      {
         labelField = "label";
         itm = {label:itm};
      }
      this.addNode(new FTreeNode(itm[labelField],itm[dataField]));
      i++;
   }
   return this;
};
FTreeNode.prototype.setIconSymbolName = function(iconSymbolName)
{
   this.iconSymbolName = iconSymbolName;
   return this;
};
FTreeNode.prototype.setIsBranch = function()
{
   this.branch = true;
   return this;
};
FTreeNode.prototype.setIsOpen = function(isOpen)
{
   this.open = isOpen;
   return this;
};
FTreeNode.prototype.setLabel = function(label)
{
   this.label = label;
   return this;
};
FTreeNode.prototype.setNodeProperties = function(label, data)
{
   this.label = label;
   this.data = data;
   return this;
};
FTreeNode.prototype.countChildren = function()
{
   var i;
   var c = 0;
   i = 0;
   while(i < this.length)
   {
      c++;
      this[i].level = this.level + 1;
      if(this[i].isBranch())
      {
         c += this[i].countChildren();
      }
      i++;
   }
   this.numchildren = c;
   return c;
};
FTreeNode.prototype.isAncestor = function(descendent)
{
   var ret = false;
   var ca = descendent;
   while(!ret && ca != null)
   {
      ret = ca.__ID__ == this.__ID__;
      ca = ca.parent;
   }
   return ret;
};
FTreeNode.prototype.isOnOpenBranch = function()
{
   var ret = true;
   var cp = this.parent;
   while(ret && cp != null)
   {
      ret &= cp.isOpen();
      cp = cp.parent;
   }
   return ret;
};
FTreeNode.prototype.setParentNode = function(parent)
{
   this.parent = parent;
};
