function FTreeSelectableItemClass()
{
   this.init();
}
FTreeSelectableItemClass.prototype = new FSelectableItemClass();
Object.registerClass("FTreeSelectableItemSymbol",FTreeSelectableItemClass);
FTreeSelectableItemClass.prototype.kConnectorColWidth = 17;
FTreeSelectableItemClass.prototype.layoutContent = function(width)
{
   this.attachMovie("FLabelSymbol","fLabel_mc",2,{hostComponent:this.controller});
   this.fLabel_mc._x = 2;
   this.fLabel_mc._y = 0;
   this.fLabel_mc.setSize(width - 2);
   this.fLabel_mc.labelField.autosize = true;
   this.fLabel_mc.labelField.selectable = false;
   this.fLabel_mc.labelField.embedFonts = true;
};
FTreeSelectableItemClass.prototype.displayContent = function(nodeObj, selected)
{
   if(this.fLabel_mc.labelField.text != nodeObj.label)
   {
      this.fLabel_mc.setLabel(nodeObj.label + " ");
   }
   var clr = !selected ? this.controller.styleTable.textColor.value : this.controller.styleTable.textSelected.value;
   if(clr == undefined)
   {
      clr = !selected ? 0 : 16777215;
   }
   this.fLabel_mc.setColor(clr);
   var icon = nodeObj == null ? null : nodeObj.getIconSymbolName();
   if(icon == null)
   {
      icon = this.controller.getDefaultNodeIconSymbolName();
   }
   if(nodeObj == null || this.fIcon_name != icon)
   {
      this.fIcon_mc.removeMovieClip();
      this.fIcon_name = null;
   }
   this.cn.removeMovieClip();
   if(!(nodeObj instanceof FTreeNode))
   {
      return undefined;
   }
   nodeObj.ui = this;
   var lvl = nodeObj.level;
   var cl = lvl;
   var cp = nodeObj.getParentNode();
   this.createEmptyMovieClip("cn",3001);
   var cn = this.cn;
   var ch = this.highlight_mc._height;
   var cw = this.kConnectorColWidth;
   var cnCol = this.controller.styleTable.highlight3D.value;
   if(cnCol == undefined)
   {
      cnCol = 8421504;
   }
   cn._x = 2;
   while(cl >= 0)
   {
      cn.lineStyle(0,cnCol,0);
      var x0 = cl * cw;
      cn.moveTo(x0,0);
      cn.lineTo(x0,ch - 1);
      cn.lineTo(x0 + cw - 1,ch - 1);
      var my = Math.floor(ch / 2);
      var mx = Math.floor(cw / 2);
      if(cl == lvl)
      {
         this.mx = mx + cl * cw;
         this.my = my;
      }
      if(this.controller.getDrawConnectors())
      {
         var mx = Math.floor(cw / 2);
         x0 = cl * cw + mx;
         if(cl == lvl)
         {
            var pn = nodeObj.getParentNode();
            if(pn == null || nodeObj.index == pn.length - 1)
            {
               cn.lineStyle(1,cnCol,100);
               cn.moveTo(x0,0);
               cn.lineTo(x0,my);
               cn.moveTo(x0,my);
               cn.lineTo(x0 + mx - 1,my);
            }
            else
            {
               cn.lineStyle(1,cnCol,100);
               cn.moveTo(x0,0);
               cn.lineTo(x0,ch - 1);
               cn.moveTo(x0,my);
               cn.lineTo(x0 + mx - 1,my);
            }
         }
         else if(cp != null)
         {
            var pn = cp.getParentNode();
            if(pn != null && pn.length > 1 && cp.index < pn.length - 1)
            {
               cn.lineStyle(1,cnCol,100);
               cn.moveTo(x0,0);
               cn.lineTo(x0,ch - 1);
            }
            cp = pn;
         }
      }
      cl--;
   }
   if(nodeObj.isBranch())
   {
      var sn = this.controller.getExpanderSymbolName();
      if(sn != undefined)
      {
         this.attachExpander(cn,sn,cw,nodeObj);
      }
      else
      {
         this.drawExpander(cn,nodeObj,cw,selected);
      }
      var ex = cn.ex;
      ex.node = nodeObj;
      ex.controller = this;
      ex.useHandCursor = false;
      ex.trackAsMenu = true;
      var trigger = "onRelease";
      if(this.controller.getExpandNodeTrigger() == "press")
      {
         trigger = "onPress";
      }
      ex.trigger = trigger;
      ex[trigger] = function()
      {
         var tree = this.controller.controller;
         if(tree.getEnabled())
         {
            var absloc = this.controller.getItemIndex();
            this.node.setIsOpen(!this.node.isOpen());
            tree.dataProvider.updateBranch(absloc);
            if(!tree.focused)
            {
               tree.pressFocus();
            }
            if(tree.expansionHandlerObj != undefined)
            {
               tree.expansionHandlerObj[tree.expansionHandlerFxn](tree,this.node);
            }
            tree.invalidate("resetTreeWidth");
         }
      };
   }
   var offset = cn._x + cn._width;
   if(this.fIcon_mc == undefined)
   {
      this.attachMovie(icon,"fIcon_mc",3000);
      this.fIcon_name = icon;
   }
   this.fIcon_mc._x = Math.round(offset);
   this.fIcon_mc._y = Math.round((ch - this.fIcon_mc._height) / 2);
   var frame = "leaf";
   if(nodeObj.isBranch())
   {
      frame = !nodeObj.isOpen() ? "branchClosed" : "branchOpen";
   }
   this.fIcon_mc.controller = this;
   this.fIcon_mc.node = nodeObj;
   this.fIcon_mc.onPress = this.controller.iconDoubleClick;
   this.fIcon_mc.useHandCursor = false;
   this.fIcon_mc.gotoAndStop(frame);
   offset += this.fIcon_mc._width + 4;
   this.fLabel_mc._x = Math.round(offset);
   if(this.controller.itmHgt < ch)
   {
      this.fLabel_mc._y = Math.round((ch - this.controller.itmHgt) / 2);
   }
   if(nodeObj != null)
   {
      var lf = this.fLabel_mc.labelField;
      nodeObj.width = offset + lf._x + lf.textwidth;
      this.controller.setTreeWidth(nodeObj.width);
   }
   this._y = Math.round(this._y);
};
FTreeSelectableItemClass.prototype.attachExpander = function(parentClip, symbolName, width, nodeObj)
{
   var exframe = !nodeObj.isOpen() ? "closed" : "opened";
   var cn = parentClip;
   var cw = width;
   cn.attachMovie(symbolName,"ex",1);
   var ex = cn.ex;
   if(ex._width > cw)
   {
      ex._height *= cw / ex._width;
      ex._width = cw;
   }
   if(ex._height > cn._height)
   {
      ex._width *= cn._height / ex._height;
      ex._height = cn._height;
   }
   ex._x = Math.round(((2 * nodeObj.level + 1) * cw - ex._width) / 2);
   ex._y = Math.round((cn._height - ex._height) / 2);
   ex.gotoAndStop(exframe);
};
FTreeSelectableItemClass.prototype.drawExpander = function(parentClip, nodeObj, width, selected)
{
   var cn = parentClip;
   var cw = width;
   cn.createEmptyMovieClip("ex",1);
   var ex = cn.ex;
   var excol = this.controller.styleTable.highlight3D.value;
   if(excol == undefined)
   {
      excol = 8421504;
   }
   var exfill;
   exfill = this.controller.styleTable.background.value;
   if(exfill == undefined)
   {
      exfill = 16777215;
   }
   var mx = Math.floor(cw / 2) + 1;
   ex.lineStyle(0,0,0);
   ex.beginFill(excol);
   ex.moveTo(0,0);
   ex.lineTo(0,mx);
   ex.lineTo(mx,mx);
   ex.lineTo(mx,0);
   ex.lineTo(0,0);
   ex.endFill();
   ex.lineStyle(0,0,0);
   ex.beginFill(exfill);
   ex.moveTo(1,1);
   ex.lineTo(1,mx - 1);
   ex.lineTo(mx - 1,mx - 1);
   ex.lineTo(mx - 1,1);
   ex.lineTo(1,1);
   ex.endFill();
   excol = this.controller.styleTable.darkshadow.value;
   if(excol == undefined)
   {
      excol = 0;
   }
   ex.lineStyle(0,0,0);
   var mid = Math.floor(mx / 2);
   ex.beginFill(excol);
   ex.moveTo(2,mid);
   ex.lineTo(mx - 2,mid);
   ex.lineTo(mx - 2,mid + 1);
   ex.lineTo(2,mid + 1);
   ex.lineTo(2,mid);
   ex.endFill();
   if(!nodeObj.isOpen())
   {
      ex.moveTo(mid,2);
      ex.beginFill(excol);
      ex.lineTo(mid,mx - 2);
      ex.lineTo(mid + 1,mx - 2);
      ex.lineTo(mid + 1,2);
      ex.lineTo(mid,2);
      ex.endFill();
   }
   ex._x = Math.floor(this.mx - mid);
   ex._y = Math.floor(this.my - mid);
};
